﻿using DxPackNet;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CamFrameCallBack
{
    public partial class Form1 : Form
    {
        IDxCameraCapture camCapture;
        DxDeviceCollection cameras;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            camCapture.Run();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cameras = DxFactory.CreateDxCompent<DxDeviceCollection>(DxDeviceCollection.ENVIRONMENT_CAMERAS);
            camCapture = DxFactory.CreateDxCompent<IDxCameraCapture>(this, panel1);
            camCapture.FrameCb = camerasFrameCb;
            camCapture.Init(cameras[0]);
        }
        private void camerasFrameCb(byte[] buffer, int size)
        {
            //注意-这里必须把数据拿到创建控件的线程上处理
            this.BeginInvoke(new camerasFrameCbHandler(_camerasFrameCb), buffer, size);
        }

        delegate void camerasFrameCbHandler(byte[] buffer, int size);
        public void _camerasFrameCb(byte[] buffer, int size)
        {
            //根据数据流获取适配的bmp图片对象
            Bitmap bmp = camCapture.BmpFromBuffer(buffer, size);
            if (bmp != null)
            {
                Image oimg = pictureBox1.Image;
                pictureBox1.Image = bmp;
                if (oimg != null) oimg.Dispose();
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            camCapture.Dispose();
            cameras.Dispose();
        }
    }
}
